/*
 history:
  Aug99
  - gets replaced by fgets
  - maxcalc inserted (to stop long calculations)
 plan:
  - teilweise statt volle Tiefensuche (tiefer nur fuer jeweils besten zug)

 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#define version_string "0.1.2 12/93"
#define bsize 28
#define MAXZ  100
#define    ANFANG "........................991"
/* 24*brett(SPC=frei,1=weiss,2=schwarz)
    1*anz eigene Steine zum einsetzten weiss
    1*anz eigene Steine zum einsetzten schwarz
    1*Spieler (1/2 am zug)

         +-----+-----+       a-----b-----c
         | +---+---+ |       | i---j---k |
         | | +-+-+ | |       | | q-r-s | |
         +-+-+   +-+-+       h-p-x   t-l-d
         | | +-+-+ | |       | | w-v-u | |
         | +---+---+ |       | o---n---m |
         +-----+-----+       g-----f-----e
     
    a.out [?zugtiefe?] [quitemode]

*/

FILE *fd1;
int mode=0;
int zugtiefe=2;      /* rekursive Zugtiefe (zeitexponentiell) */
int maxcalc=10000;  /* maximale Anzahl berechenbarer Zuege (zeitlinear) */
int numcalc=0;

void outbrett(brett) char *brett;
{ int i,j; /* 201 205 187   186    200 205 188 */
  int aab[24]={0,6,12,51,90,84,78,39,15,19,23,49,75,71,67,41,30,32,34,47,60,58,56,43};
#if 0		/* old dos-version */
  char aaa[100]="Ŀ Ŀ   Ŀ  Ĵ   Ĵ      ";
  char aac[100]="abc ijk   qrs  hpx   tld  wvu   onm gfe";
#else		/* new unix-version */
  char aaa[100]="+-----+-----+| +---+---+ || | +-+-+ | |+-+-+   +-+-+| | +-+-+ | || +---+---+ |+-----+-----+";
  char aac[100]="a-----b-----c| i---j---k || | q-r-s | |h-p-x   t-l-d| | w-v-u | || o---n---m |g-----f-----e";
#endif
  char c[2]="O#";
  for(i=0;i<24;i++)if(brett[i]!='.')aaa[aab[i]]=c[brett[i]-'1'];
  for(i=0;i<7;i++)
  {printf("\r\n  ");for(j=0;j<13;j++)printf("%c",aaa[13*i+j]);
   printf("      ");for(j=0;j<13;j++)printf("%c",aac[13*i+j]);}
  fflush(stdout);
}

int setze(brett,zug,b2) char *brett,*zug,*b2; /* ohne farbe aendern */
{ b2[bsize-1]=0;                          /* against overflow (strcpy) */ 
  strcpy(b2,brett);
  if(brett[zug[0]-'a']=='.')              /* Mode: Stein einsetzen */
  {   b2[24+brett[26]-'1']--;
      b2[zug[0]-'a']=brett[26];           /* setzen */
      if(zug[1]!='.')b2[zug[1]-'a']='.';  /* wegnehmen */
  }   else                                /* Mode: Stein schieben|hpfen */
  {   b2[zug[1]-'a']=brett[zug[0]-'a'];   /* nach */
      b2[zug[0]-'a']='.';                 /* von */
      if(zug[2]!='.')b2[zug[2]-'a']='.';  /* wegnehmen */
  };  b2[26]='2'+'1'-brett[26];
  return(0);
}

/* liefert 0=no cmuehle,1=muehle */
int muehle(b,p) char *b;int p;
{ int i,j;
  i=b[p];if(i=='.')return(0);
  if((p&1)==0){
   j=p+1;if((p&7)>6)j=p-7;if(b[j]==i){j=p+2;if((p&7)>5)j=p-6;if(b[j]==i)return(1);}
   j=p-1;if((p&7)<1)j=p+7;if(b[j]==i){j=p-2;if((p&7)<2)j=p+6;if(b[j]==i)return(1);}}
  else {
   if(b[p-1]==i){j=p+1;if((p&7)>6)j=p-7;if(b[j]==i)return(1);}
   if((b[(p+8)%24]==i)&&(b[(p+16)%24]==i))return(1);}
  return(0);
}

/* liefert liste aller moeglichen zuege  0=verloren */
int zgen(brett,zug) char *brett,*zug;
{   int nr=0,i,j,k,l;char b2[bsize]=ANFANG,s1[4]="123";
    zug[0]=0;
    i=0;for(j=0;j<24;j++)if(brett[j]==brett[26])i++; /* Anzahl Steine */
    if(brett[24+brett[26]-'1']!='0') /* Mode: Stein einsetzen */
    {   for(i=0;i<24;i++) if(brett[i]=='.')
        {   s1[0]=i+'a';s1[1]=' ';s1[2]=' ';s1[3]=0;
            setze(brett,s1,b2);k=0;
            if(muehle(b2,i)!=0)
            for(j=0;j<24;j++)if(brett[j]=='1'+'2'-brett[26])
            {   s1[0]=i+'a';s1[1]=j+'a';s1[2]=' ';s1[3]=0;
                if(muehle(brett,j)==0){strcat(zug,s1);nr++;k=1;}
            } if(k==0)
            {   s1[0]=i+'a';s1[1]=' ';s1[2]=' ';s1[3]=0;
                strcat(zug,s1);nr++;
            }
        }
    } else if(i>3)                   /* Mode: Stein schieben */
    { for(i=0;i<24;i++) if(brett[i]==brett[26])
      { l=i+1;if((i&7)>6)l=i-7;
        if(brett[l]=='.')
        {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=' ';s1[3]=0;
            setze(brett,s1,b2);k=0;
            if(muehle(b2,l)!=0)
            for(j=0;j<24;j++)if(brett[j]=='1'+'2'-brett[26])
            {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=j+'a';s1[3]=0;
                if(muehle(brett,j)==0){strcat(zug,s1);nr++;k=1;}
            } 
            if(k==0)
            {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=' ';s1[3]=0;
                strcat(zug,s1);nr++;
            }
        }
        l=i-1;if((i&7)<1)l=i+7;
        if(brett[l]=='.')
        {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=' ';s1[3]=0;
            setze(brett,s1,b2);k=0;
            if(muehle(b2,l)!=0)
            for(j=0;j<24;j++)if(brett[j]=='1'+'2'-brett[26])
            {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=j+'a';s1[3]=0;
                if(muehle(brett,j)==0){strcat(zug,s1);nr++;k=1;}
            } 
            if(k==0)
            {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=' ';s1[3]=0;
                strcat(zug,s1);nr++;
            }
        }
        if(((i&1)==1)&&(i/8<2))
        { l=(i+8)%24;if(brett[l]=='.')
          {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=' ';s1[3]=0;
              setze(brett,s1,b2);k=0;
              if(muehle(b2,l)!=0)
              for(j=0;j<24;j++)if(brett[j]=='1'+'2'-brett[26])
              {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=j+'a';s1[3]=0;
                  if(muehle(brett,j)==0){strcat(zug,s1);nr++;k=1;}
              } if(k==0)
              {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=' ';s1[3]=0;
                  strcat(zug,s1);nr++;
              }
          }
        }
        if(((i&1)==1)&&(i/8>0))
        { l=(i+16)%24;if(brett[l]=='.')
          {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=' ';s1[3]=0;
              setze(brett,s1,b2);k=0;
              if(muehle(b2,l)!=0)
              for(j=0;j<24;j++)if(brett[j]=='1'+'2'-brett[26])
              {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=j+'a';s1[3]=0;
                  if(muehle(brett,j)==0){strcat(zug,s1);nr++;k=1;}
              } if(k==0)
              {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=' ';s1[3]=0;
                  strcat(zug,s1);nr++;
              }
          }
        }
      }
    } else if(i==3)                  /* Mode: huepfen */
    {   for(i=0;i<24;i++) if(brett[i]==brett[26])
        for(l=0;l<24;l++) if(brett[l]=='.')
        {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=' ';s1[3]=0;
            setze(brett,s1,b2);k=0;
            if(muehle(b2,l)!=0)
            for(j=0;j<24;j++)if(brett[j]=='1'+'2'-brett[26])
            {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=j+'a';s1[3]=0;
                if(muehle(brett,j)==0){strcat(zug,s1);nr++;k=1;}
            } if(k==0)
            {   s1[0]=i+'a';s1[1]=l+'a';s1[2]=' ';s1[3]=0;
                strcat(zug,s1);nr++;
            }
        }
    };
    return(nr);
}

/* bewerte stellung, farbe am zug, rekursiv */
int wert(brett,farbe,tiefe) int farbe,tiefe;char *brett;
{ int i,j,w=0,w1=0,w2; /* hier locales array best punkte, stepwise deeper */
  char z1[MAXZ][3],s1[4]="   ",b2[bsize]=ANFANG;
  static int mill[16][3]={
    { 0, 1, 2},{ 2, 3, 4},{ 4, 5, 6},{ 6, 7, 0},
    { 8, 9,10},{10,11,12},{12,13,14},{14,15, 8},
    {16,17,18},{18,19,20},{20,21,22},{23,24,16},
    { 1, 9,17},{ 3,11,19},{ 5,13,21},{ 7,15,23}};
  numcalc++;
  j=zgen(brett,z1);if(j<1) return(-9999);
  if(tiefe>0)
  { 
    { 
      w1=-9999;
      for(i=0;i<j;i++)
      { strncpy(s1,z1[i],3);s1[3]=0;setze(brett,s1,b2);
        w2=-wert(b2,1-farbe,tiefe-1); /* min-max  printf(" %9s:%5d",s1,w2);*/
        if(w2>w1) w1=w2;
        if(w2==9999) break;
      };
      w=w1;
    }
  } else 
  {
    for(i=0;i<24;i++)if(brett[i]!='.')
    {if(brett[i]=='1'+farbe)w+=20;else w-=20;}
    for(i=0;i<16;i++){ w1=w2=0;
      for(j=0;j<3;j++)
      if(brett[mill[i][j]]!='.')
      { if(brett[mill[i][j]]=='1'+farbe) w1+=2-(zugtiefe & 1);
        else w2+=1+(zugtiefe & 1); 
      }
      if(w1==0 || w2==0) w+=w1-w2;	/* fast muehlen */
    }
  }
  return(w);
};

int strnicmp(char *s1, char *s2, int n){ /* Aug99 fuer linux-version */
  int i,r=0;
  for(i=0;i<n;i++){
    if(s1[i]!=s2[i]){r=1;break;}
    if(s1[i]==0) break;
    if(s2[i]==0) break;
  }
  return r;
}

/* lev: 0=player, 1=computer */
int play1(brett,lev) char *brett;
{    char s1[10]="bye       ",s2[2][8]={"  weiss","schwarz"},
          z2[MAXZ][3],b2[bsize]=ANFANG;
     int i,j,i1,i2,w1,w2,best,farbe;
     farbe=brett[26]-'1';if(mode!=1)
     {outbrett(brett);printf("  %s am Zug,",s2[farbe]);};
     j=zgen(brett,z2);
#if 0		/* for debugging set to 1 else to 0 */
     printf("\n%4d Zuege:",j);
     for(i1=0;i1<j;i1++) printf(" %c%c%c",z2[i1][0],z2[i1][1],z2[i1][2]);
     printf("\n");
#endif
     if(lev==0)
     { if(j>0) do
       { printf(" Ihr Zug: ");fgets(s1,10,stdin);
         if(s1[1]==0 || s1[1]=='\n'){s1[2]=0;s1[1]=' ';};
         if(s1[2]==0 || s1[2]=='\n'){s1[3]=0;s1[2]=' ';};
         if((strstr(s1,"bye\n")!=NULL)||(strstr(s1,"quit\n")!=NULL)
          ||(strstr(s1,"exit\n")!=NULL)||(strstr(s1,".\n")!=NULL)) exit(0);
         i2=0;for(i1=j-1;i1>=0;i1--){if(strnicmp(s1,z2[i1],3)==0)i2=1;};
       } while(i2==0);
     } else
     if(lev==1)
     { if(j>0)
       { best=0;w1=-9999;
         if(j>1)for(i=0;i<j;i++)
         { strncpy(s1,z2[i],3);s1[3]=0;setze(brett,s1,b2);numcalc=0;
           w2=-wert(b2,1-farbe,zugtiefe); /* printf(" %9s:%5d",s1,w2); */
           if((w2>w1)||((w2==w1)&&((rand()%2)==0))){w1=w2;best=i;};
           /* printf(" (%s %d)",s1,w2); */
         };strncpy(s1,z2[best],3);s1[3]=0;if(mode!=1)
         printf(" Mein Zug: %s (%d)",s1,w1);
       };
     };
     i=1;if(j>0) i=setze(brett,s1,brett);
     /* if(farbe==0) fprintf(fd1,"\n");fprintf(fd1,"%5s",s1);*/
     if(j>0)fprintf(fd1,"\n%s",brett);else fprintf(fd1,"\n---");
     return(i);
}


int main(argn,argv) int argn;char *argv[];          /* Hauptprogramm */
{ int i;char brett[bsize+10]=ANFANG;
  if(argn>2)mode=1; /* quietmode mit zB: TP-Oberflaeche aus Batchdatei */
  if(argn>1)zugtiefe=atoi(argv[1]);
  if(mode==0){
   for(i=0;i<argn;i++) printf(" %s",argv[i]);srand((unsigned)time(NULL));
   printf("\r\nJMuehle by Joerg Schulenburg, v931229\r\n");
   printf("\r\n Eingaben: [<von>]<nach>[<weg>]|bye  (von,nach,weg:Feld A..X)");
   fd1=fopen("jmuehle.out","w+t");fprintf(fd1,"%s",brett);
   for(i=0;i==0;) {if((i=play1(brett,0))==0) i=play1(brett,1);}
   fclose(fd1);}
  else{ 
   fd1=fopen("jmuehle.out","r+t");if(fd1==NULL)
   {fd1=fopen("jmuehle.out","w+t");fprintf(fd1,"%s",brett);}else
   {
      while(!feof(fd1)) fgets(brett,bsize+9,fd1); /* inclusive trailing \n */
      brett[bsize-1]=0;
      if(brett[bsize-2]<'1' || brett[bsize-2]>'2') return(2);
      if(brett[bsize-3]<'0' || brett[bsize-3]>'9') return(2);
      if(brett[bsize-4]<'0' || brett[bsize-4]>'9') return(2);
      i=play1(brett,1);
   }
   fclose(fd1);
   return(0);/* ok */}
  return(1);
}
