#!/usr/X11R6/bin/wish
# jmuehle.tcl --
#
# graphical frontend for the jmuehle program
#  jmuehle ?level? -q 
#  (modes: q=play, moegliche spielzuege (woher, wohin,
#   muehlen?, wegnehmen?))
#
#  F10 - aktivate menu
#  TAB - go to next button/widget
#  SPC - press button
#
#  its propably not the best code, but it works
#
# @(#) muehle.tcl 1.1 99/08/26 15:56:35
#
# tcl-help: man n ?tcl-command?
#

set font -*-Helvetica-Medium-R-Normal--*-140-*-*-*-*-*-*

# name of the main-widget-window
set w ""
wm title . "Muehle"
wm iconname . "Muehle"
wm geometry . +200+10
set c $w.c
set nextmove "start"

frame .menu -relief raised -bd 2
pack .menu -side top -fill x

set m .menu.file.m
menubutton .menu.file -text "Optionen (F10)" -menu $m -underline 0
menu $m
$m add command -label "Neues Spiel" -command { New_game }
$m add command -label "Zeichne neu" -command { RePlot }
$m add command -label "Ruecknehmen" -command {set fieldz(field) $fieldz(f_old); RePlot }
$m add command -label "Lade Spiel"  -command { loadField }
$m add command -label "Stufe = 0"  -command {set fieldz(level) 0}
$m add command -label "Stufe + 1"  -command {set fieldz(level) [expr $fieldz(level) + 1]}
$m add separator
$m add command -label "Ende" -command "destroy ."

set m $w.menu.help.m
menubutton $w.menu.help -text "Hilfe" -menu $m -underline 0
menu $m
$m add command -label "Info"   -command { aboutBox }
$m add command -label "Regeln" -command { TextWin "Rules ..." }

#pack $w.menu.file $w.menu.help -side left
pack $w.menu.file -side left
pack $w.menu.help -side right


frame $w.status -height 1 -width 10
pack $w.status -side top -expand yes
label $w.status.level21 -text "Spielstufe: "
entry $w.status.level2  -textvariable fieldz(level) -width 2
#scale $w.status.level -from 0 -to 5 -length 100 -tickinterval 2 \
# -orient horizontal -variable fieldz(level) -showvalue no
label $w.status.zug1 -text "  Zug: "
entry $w.status.zug2  -textvariable nextmove -width 5
pack $w.status.level21 $w.status.level2 -side left
#pack $w.status.level -side left -expand yes
pack $w.status.zug1 $w.status.zug2 -side left -expand yes

frame $w.buttons
pack  $w.buttons -side bottom -expand y -fill x -pady 2m
button $w.buttons.dismiss -text "Ende"   -command "destroy ."
button $w.buttons.code    -text "Weiter" -command "nextMove ."
pack $w.buttons.dismiss $w.buttons.code -side left -expand 1

canvas $c -relief raised -width 450 -height 370
pack $w.c -side top -fill x


set plotFont -*-Helvetica-Medium-R-Normal--*-180-*-*-*-*-*-*

# level: game level
set fieldz(level) 1
set fieldz(field) "........................991"
set fieldz(f_old) "........................991"
#                  ^^^^^^^^^^^^^^^^^^^^^^^^    board fields
#                                          ^^  stones left for insertion
#                                            ^ who makes the next turn 
set fieldz(fname) "abcdefghifklmnopqrstuvwx"
set fieldz(tmp1)  Yellow
# set to 1, if blue has made his turn

proc New_game { } {
  global fieldz
  set fieldz(field) "........................991"
  set fieldz(f_old) "........................991"
  set fieldz(fname) "abcdefghifklmnopqrstuvwx"
  puts "start new game level $fieldz(level)"
  RePlot
}

proc TextWin { text } {
    global tk_library
    set file ./Rules.txt
    if ![winfo exists .code] {
        toplevel .code
        frame .code.buttons
        pack .code.buttons -side bottom -fill x
        button .code.buttons.dismiss -text Dismiss -command "destroy .code"
        pack .code.buttons.dismiss -side left -expand 1 -pady 2
        frame .code.frame
        pack  .code.frame -expand yes -fill both -padx 1 -pady 1
        text .code.text -height 40 -wrap word\
            -xscrollcommand ".code.xscroll set" \
            -yscrollcommand ".code.yscroll set" \
            -setgrid 1 -highlightthickness 0 -pady 2 -padx 3
        scrollbar .code.xscroll -command ".code.text xview" \
            -highlightthickness 0 -orient horizontal
        scrollbar .code.yscroll -command ".code.text yview" \
            -highlightthickness 0 -orient vertical

        grid .code.text -in .code.frame -padx 1 -pady 1 \
            -row 0 -column 0 -rowspan 1 -columnspan 1 -sticky news
        grid .code.yscroll -in .code.frame -padx 1 -pady 1 \
            -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news
#       grid .code.xscroll -in .code.frame -padx 1 -pady 1 \
#           -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
        grid rowconfig    .code.frame 0 -weight 1 -minsize 0
        grid columnconfig .code.frame 0 -weight 1 -minsize 0
    } else {
        wm deiconify .code
        raise .code
    }
    wm title .code "Muehle Regeln"
    wm iconname .code Regeln
    set id [open $file]
    .code.text delete 1.0 end
    .code.text insert 1.0 [read $id]
    .code.text mark set insert 1.0
    close $id
}

# aboutBox --
#
#       Pops up a message box with an "about" message
#
proc aboutBox {} {
    tk_messageBox -icon info -type ok -title "Info" -message \
"Muehle frontend fuer JMUEHLE\n\n\
(w) 1999 Joerg.Schulenburg@physik.uni-magdeburg.de"
}


proc RePlot { } {
   global c fieldz
   # 2 x 9 chips auf Seite bereitlegen !?
   $c delete all
   # horizontale
   $c create line  50  50 350  50 -width 2
   $c create line 100 100 300 100 -width 2
   $c create line 150 150 250 150 -width 2
   $c create line  50 200 150 200 -width 2
   $c create line 250 200 350 200 -width 2
   $c create line 150 250 250 250 -width 2
   $c create line 100 300 300 300 -width 2
   $c create line  50 350 350 350 -width 2
   #vertikale
   $c create line  50  50  50 350 -width 2
   $c create line 100 100 100 300 -width 2
   $c create line 150 150 150 250 -width 2
   $c create line 200  50 200 150 -width 2
   $c create line 200 250 200 350 -width 2
   $c create line 250 150 250 250 -width 2
   $c create line 300 100 300 300 -width 2
   $c create line 350  50 350 350 -width 2

   foreach point {{400 10 0} {400 20 1} {400 30 2} {400 40 3} {400 50 4}
   	{400 60 5} {400 70 6} {400 80 7} {400 90 8}} {

     if [expr [lindex $point 2] < [string index $fieldz(field) 24] ] {
       set x [expr {[lindex $point 0]}]
       set y [expr {50+2*[lindex $point 1]}]
       set item [$c create oval [expr $x-6] [expr $y-6] \
   	    [expr $x+6] [expr $y+6] -width 1 -outline black \
   	    -fill Blue]
       $c addtag point withtag $item
     }
     if [expr [lindex $point 2] < [string index $fieldz(field) 25] ] {
       set x [expr {20+[lindex $point 0]}]
       set y [expr {50+2*[lindex $point 1]}]
       set item [$c create oval [expr $x-6] [expr $y-6] \
   	    [expr $x+6] [expr $y+6] -width 1 -outline black \
   	    -fill Yellow]
       $c addtag point2 withtag $item
     }
   }

   set line $fieldz(field)
#   puts "plot=$line"
   foreach point {{ 50  50 a  0} {200  50 b  1} {350  50 c  2}
                  {350 200 d  3} {350 350 e  4} {200 350 f  5}
		  { 50 350 g  6} { 50 200 h  7} {100 100 i  8}
		  {200 100 j  9} {300 100 k 10} {300 200 l 11}
                  {300 300 m 12} {200 300 n 13} {100 300 o 14}
                  {100 200 p 15} {150 150 q 16} {200 150 r 17}
		  {250 150 s 18} {250 200 t 19} {250 250 u 20}
		  {200 250 v 21} {150 250 w 22} {150 200 x 23}} {
     set idx [expr {[lindex $point 3]}]
     set stone [string index "$line" $idx]
     if [ expr [string compare "$stone" "2"] == 0 ] {
       set x [lindex $point 0]
       set y [lindex $point 1]
       set item [$c create oval [expr $x-6] [expr $y-6] \
   	    [expr $x+6] [expr $y+6] -width 1 -outline black \
   	    -fill Yellow]
       $c addtag point2 withtag $item
     }
     if [ expr [string compare "$stone" "1"] == 0 ] {
       set x [lindex $point 0]
       set y [lindex $point 1]
       set item [$c create oval [expr $x-6] [expr $y-6] \
   	    [expr $x+6] [expr $y+6] -width 1 -outline black \
   	    -fill Blue]
       $c addtag point withtag $item
     }
   }

   $c bind point <Any-Enter> "$c itemconfig current -fill red"
   $c bind point <Any-Leave> "$c itemconfig current -fill Blue"
   # ------ druecken der mouse-taste
   $c bind point <1> "plotDown $c %x %y"
   # ------ loslassen der Mouse-Taste
   # $c bind point <ButtonRelease-1> "$c dtag selected"
   $c bind point <ButtonRelease-1> "plotUp $c %x %y"
   bind $c <B1-Motion> "plotMove $c %x %y"

   $c bind point2 <Any-Enter> "$c itemconfig current -fill red;set fieldz(tmp1) Yellow"
   $c bind point2 <Any-Leave> "$c itemconfig current -fill \$fieldz(tmp1)"
   $c bind point2 <ButtonRelease-1> "plotUp2 $c %x %y;set fieldz(tmp1) Red"
#   bind $c <B1-Motion> "plotMove $c %x %y"
   set fieldz(tmp1) Yellow
}

# substitute char number $num od $string by $new
# ersetzen durch: string range string first last

proc string_subs { str num new } {
#  puts "subi=$str num=$num new=$new"
  foreach i {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26} {
    set field($i) [string index $str $i]
  }
  if [expr $num >= 0] {
    if [expr $num < 27] {
      set field($num) $new
    }
  }
  set ret ""
  foreach i {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26} {
    set ret $ret$field($i)
  }
#  puts "subo=$ret"
  return $ret
}

# mehrere Variablen unter rubrik plot: lastX lastY lastF

set plot(lastX) 0
set plot(lastY) 0
set plot(lastF) ""
RePlot

# test string_subs (ok)
#puts $fieldz(field)
#puts [string_subs $fieldz(field) 2 "x"]



# plotDown --
# This procedure is invoked when the mouse is pressed over one of the
# data points.  It sets up state to allow the point to be dragged.
#
# Arguments:
# w -		The canvas window.
# x, y -	The coordinates of the mouse press.
#          [] substitution

proc plotDown {w x y} {
    global plot nextmove fieldz
    set nextmove ""
    set plot(lastF) "-"
    foreach point {{ 50  50 a  0} {200  50 b  1} {350  50 c  2}
                   {350 200 d  3} {350 350 e  4} {200 350 f  5}
 		   { 50 350 g  6} { 50 200 h  7} {100 100 i  8}
 		   {200 100 j  9} {300 100 k 10} {300 200 l 11}
                   {300 300 m 12} {200 300 n 13} {100 300 o 14}
                   {100 200 p 15} {150 150 q 16} {200 150 r 17}
 		   {250 150 s 18} {250 200 t 19} {250 250 u 20}
 		   {200 250 v 21} {150 250 w 22} {150 200 x 23}} {
      set tx [expr {[lindex $point 0]}]
      set ty [expr {[lindex $point 1]}]
      if [expr $x <  $tx+25] { 
       if [expr $x >  $tx-25] { 
        if [expr $y <  $ty+25] { 
         if [expr $y >  $ty-25] { 
           set plot(lastF) [lindex $point 2]
           set nextmove $plot(lastF)
           set fieldz(field) [string_subs $fieldz(field) [lindex $point 3] "."]
         }
        }
       }
      }
    }
    $w dtag selected
    $w addtag selected withtag current
    $w raise current
    set plot(lastX) $x
    set plot(lastY) $y
# --- debug ---
#    puts -nonewline stdout "Down $fieldz(field)"
#    puts stdout " Down $plot(lastX) $plot(lastY) $plot(lastF) $nextmove"
}

proc plotUp {w x y} {
    global plot nextmove fieldz
    set plot(lastF) "-"
    foreach point {{ 50  50 a  0} {200  50 b  1} {350  50 c  2}
                   {350 200 d  3} {350 350 e  4} {200 350 f  5}
 		   { 50 350 g  6} { 50 200 h  7} {100 100 i  8}
 		   {200 100 j  9} {300 100 k 10} {300 200 l 11}
                   {300 300 m 12} {200 300 n 13} {100 300 o 14}
                   {100 200 p 15} {150 150 q 16} {200 150 r 17}
 		   {250 150 s 18} {250 200 t 19} {250 250 u 20}
 		   {200 250 v 21} {150 250 w 22} {150 200 x 23}} {
      set tx [expr {[lindex $point 0]}]
      set ty [expr {[lindex $point 1]}]
      if [expr $x <  $tx+25] { 
       if [expr $x >  $tx-25] { 
        if [expr $y <  $ty+25] { 
         if [expr $y >  $ty-25] { 
           set plot(lastF) [lindex $point 2]
           set nextmove $nextmove$plot(lastF)
           set fieldz(field) [string_subs $fieldz(field) [lindex $point 3] "1"]
         }
        }
       }
      }
    }
    $w dtag selected
    # w=.c
#    puts -nonewline stdout "move=$nextmove\n"
}

proc plotUp2 {w x y} {
    global plot nextmove fieldz
    set plot(lastF) "-"
    foreach point {{ 50  50 a  0} {200  50 b  1} {350  50 c  2}
                   {350 200 d  3} {350 350 e  4} {200 350 f  5}
 		   { 50 350 g  6} { 50 200 h  7} {100 100 i  8}
 		   {200 100 j  9} {300 100 k 10} {300 200 l 11}
                   {300 300 m 12} {200 300 n 13} {100 300 o 14}
                   {100 200 p 15} {150 150 q 16} {200 150 r 17}
 		   {250 150 s 18} {250 200 t 19} {250 250 u 20}
 		   {200 250 v 21} {150 250 w 22} {150 200 x 23}} {
      set tx [expr {[lindex $point 0]}]
      set ty [expr {[lindex $point 1]}]
      if [expr $x <  $tx+25] { 
       if [expr $x >  $tx-25] { 
        if [expr $y <  $ty+25] { 
         if [expr $y >  $ty-25] { 
           set plot(lastF) [lindex $point 2]
           set nextmove $nextmove$plot(lastF)
           set fieldz(field) [string_subs $fieldz(field) [lindex $point 3] "."]
           set fieldz(tmp1) Red
         }
        }
       }
      }
    }
    $w dtag selected
    # w=.c
#    puts -nonewline stdout "move=$nextmove\n"
}

# plotMove --
# This procedure is invoked during mouse motion events.  It drags the
# current item.
#
# Arguments:
# w -		The canvas window.
# x, y -	The coordinates of the mouse.

proc plotMove {w x y} {
# globale variablen
    global plot
    $w move selected [expr $x-$plot(lastX)] [expr $y-$plot(lastY)]
#    $w delete selected
    set plot(lastX) $x
    set plot(lastY) $y
#    puts stdout "proc plotMove"  # to often
}

proc loadField { } {
    global fieldz
    set file [open "jmuehle.out" "r"]
    while {[eof $file] == 0} {
      gets $file line
#      puts "line=$line eof=[eof $file] test=[expr {[eof $file] == 0}]"
    }
    close $file
    puts "load=$line"
    set fieldz(field) $line
    if [expr [string compare "[string index "$fieldz(field)" 0]" "-"] == 0] {
      error "some thing was going wrong, maybe someone has won"
    }
    RePlot
    set fieldz(f_old) $fieldz(field)

}

proc nextMove { w } {
    global plot nextmove fieldz c
    set line $fieldz(field)
    if [expr [string compare  "$fieldz(field)" "$fieldz(f_old)" ] != 0] {
      set tmp  [string index "$fieldz(field)" 26]
      set tmpa [string index "$fieldz(field)" [expr 23 + $tmp]]
      if [expr $tmpa > 0] {  set tmpa [expr $tmpa - 1]   }
      set line [string range "$fieldz(field)" 0 25 ][expr 3 - $tmp]
      set line [string_subs $line [expr 23 + $tmp] $tmpa] 
    }
    puts -nonewline "next=$line "
#    puts ""

    set file [open "jmuehle.out" "a+"]
    puts -nonewline $file "\n$line"
    close $file

    puts "exec=[exec jmuehle $fieldz(level) -q]"

# Ausgabe einladen und Replot
    loadField

}
